import django.views.generic.base
from django.urls import include, path
import django.conf.urls

import mini_buildd.views
import mini_buildd.admin

# pylint: disable=invalid-name

redirects = [path(target, django.views.generic.base.RedirectView.as_view(url="/" + mini_buildd.config.URIS["home"]["view"].get())) for target in ["", "mini_buildd/"]]

urlpatterns = redirects + [
    # mini_buildd
    path("<path:path>.html", mini_buildd.views.PathView.as_view()),
    path(mini_buildd.config.URIS["events"]["view"].get() + "/", mini_buildd.views.EventsLogHomeView.as_view()),
    path(mini_buildd.config.URIS["events"]["view"].get() + "/<str:distribution>/<str:source>/<str:version>/", mini_buildd.views.EventsLogView.as_view()),
    path(mini_buildd.config.URIS["buildlogs"]["view"].get() + "/<str:type>/<path:path>.buildlog", mini_buildd.views.BuildlogView.as_view()),
    path(mini_buildd.config.URIS["api"]["api"].get(), mini_buildd.views.API.as_view()),
    path(mini_buildd.config.URIS["api"]["view"].get(), mini_buildd.views.APIView.as_view()),
    path("mini_buildd/accounts/profile/", mini_buildd.views.AccountProfileView.as_view()),

    # admin
    path("admin/", mini_buildd.admin.site.urls),

    # accounts
    path("accounts/", include("django.contrib.auth.urls")),
    path("accounts/", include("registration.backends.model_activation.urls")),
]

django.conf.urls.handler400 = mini_buildd.views.ExceptionMiddleware.bad_request
django.conf.urls.handler403 = mini_buildd.views.ExceptionMiddleware.permission_denied
django.conf.urls.handler404 = mini_buildd.views.ExceptionMiddleware.page_not_found
django.conf.urls.handler500 = mini_buildd.views.ExceptionMiddleware.server_error
